local json = require("json")
local utils = require("utils")
local utils_device = require("utils_device")

local request_method = ngx.var.request_method

utils.check_login()
utils.check_permission("DeviceManage")

if ("POST" == request_method) then
    local utils_header = require("utils_header")
    local params = utils_header.check_public_boby_data()
    local pk = params["productKey"]
    local dn = params["deviceName"]
    local service_name = params["method"]
    local params = params["inputParams"]

    utils.check_pk(pk)
    utils.check_dn(dn)

    if (not (service_name and params)) then
        utils.error_exit(400, "invalid parameter")
    end

    ok, data = utils_device.call_service(pk, dn, service_name, params)
    if (not ok) then
        utils.error_exit(500, "failed to call deivce service")
    end
    
    if (data) then
        res_raw = json.encode(data)
    else
        res_raw = "{}"
    end
    
    utils.error_exit(200, res_raw)
end

utils.error_exit(400, "unsupported request method")
